extern crate gtk;
use gtk::prelude::*;
use gtk::{Label,Button, Window, WindowType};
use gtk::Entry;
#[derive(Debug)]
pub enum SquareEquationSolution {
    TwoRoots(f64, f64),
    OneRoot(f64),
    NoRoots
}

impl SquareEquationSolution {
    fn x1(a: f64, b: f64,d: f64) -> f64 {
        let x1 = (-b + d.sqrt())/(2.*a);
        x1
    }
    fn x2(a: f64,b:f64,d:f64) -> f64 {
        let x2 = (-b - d.sqrt())/(2.*a);
        x2
    }
}
fn discriminant(a: f64,b: f64, c: f64) -> f64 {
    let d = b * b - 4.*a*c;
    d
}
fn proceed_math(a: f64,b: f64,c: f64) -> SquareEquationSolution {
    let d = discriminant(a,b,c);
    match d {
        _ if d > 0. => SquareEquationSolution::TwoRoots((-b + d.sqrt())/(2.*a), (-b -  d.sqrt())/(2.*a)),
        _ if d < 0. => SquareEquationSolution::NoRoots,
        _ => SquareEquationSolution::OneRoot(-b/(2.*a)),
        
    }
}



fn main() {
    if gtk::init().is_err() {
    println!("Failed to initialize GTK.");
    return;
    }
    let glade_src = include_str!("ui.glade");
    let builder = gtk::Builder::new_from_string(glade_src);
    let button: gtk::Button = builder.get_object("proceed").unwrap();
    let window: gtk::Window = builder.get_object("window1").unwrap();
    let text_area: gtk::Label = builder.get_object("output_label").unwrap();
    let atext_entry: gtk::Entry = builder.get_object("anum").unwrap();
    let btext_entry: gtk::Entry = builder.get_object("bnu").unwrap();
    let ctext_entry: gtk::Entry = builder.get_object("cnum").unwrap();
   
    button.connect_clicked(move |_| {
        println!("Button pressed");
        let anumget = atext_entry.get_text().unwrap();
        let anum: f64 = anumget.parse().unwrap();
        let bnumget = btext_entry.get_text().unwrap();
        let bnum: f64 = bnumget.parse().unwrap();
        let cnumget = ctext_entry.get_text().unwrap();
        let cnum: f64 = cnumget.parse().unwrap();
        let d = discriminant(anum,bnum,cnum);
        
        let text = format!("{:?}\n Дискриминант: {:?}
        \n x1 = (-b + vD) / (2*a) = {}\n x2 = (-b - vD) / (2*a) = {}", proceed_math(anum,bnum,cnum),discriminant(anum,bnum,cnum),SquareEquationSolution::x1(anum,bnum,d), SquareEquationSolution::x2(anum,bnum,d));
        text_area.set_text(&text);
    });
    window.show_all();
    gtk::main();
}
